
/**
* \file GameEngine.h
*/
#ifndef _FUSION_HPP_INCLUDED
#define _FUSION_HPP_INCLUDED

#include "fusCompileConfig.hpp"


// HACK
#ifndef FUS_IRRLICHT_SUPPORT
    #define FUS_IRRLICHT_SUPPORT
#endif


#include "logging/ILogger.hpp"
#include "logging/Logger.hpp"
#include "logging/irrlicht_operators.hpp"


#ifndef FUS_ASSERT
    #define FUS_ASSERT(msg) BOOST_ASSERT(msg)
#endif

//
//#ifdef FUS_IRRLICHT_SUPPORT
//
////    #include <irrlicht.h>
//    #include "logging/irrlicht_operators.hpp"
//   // #define _IRRLICHT_SUPPORT
//#endif




#define _INFO    fus::Logger::Log(fus::ELogLevel::Notice)
//<< "[" << std::chrono::system_clock::now().time_since_epoch().count() << "]"
#define _LOG_WARNING fus::Logger::Log(fus::ELogLevel::Warning)
#define _LOG_ERROR   fus::Logger::Log(fus::ELogLevel::Error)

#ifdef FUS_DEBUG
    #define _LOG_DEBUG fus::Logger::Log(fus::ELogLevel::Notice) << "In function [" << __FUNCTION__ << "] defined in [" << __FILE__ << ":" << __LINE__ << "]"
#else
    #define _LOG_DEBUG fus::Logger::Log(fus::ELogLevel::Notice)
#endif



#ifndef M_PI
    #define M_PI 3.141592653589793238462643
#endif





#endif
