#include "IPlayerAnimator.hpp"
#include "IWalkyrieMode.hpp"
#include "../events/SCachedState.hpp"

IPlayerAnimator::IPlayerAnimator(const char* name) :
    Name(name)
{
    //ctor
}

IPlayerAnimator::~IPlayerAnimator()
{
    //dtor
}


void
CSlidingPlayerAnimator::reset()
{
    _loopCount = 0;
}



IPlayerAnimator*
CSlidingPlayerAnimator::processMove( DECLARE_PLAYER_MOVEFUNC_PARAMS )
{

    float modifier = 0.2;

    //!
    rot.Z += mode->getSpeed(ESpeed::Roll);
    if( rot.Z > 360.f){
        if(_loopCount++ > 2){
            return nullptr;
        };
    }
    pos.X += 2.f*  mode->getSpeed(ESpeed::Lateral);


    //! Move vertically
    if ( MoveForward.pressed() )
    {
        pos.Z +=  modifier * mode->getSpeed(Forward);
    }
    else if( MoveBackward.pressed() )
    {
        pos.Z -= modifier * mode->getSpeed(Forward);
    }


    return (this);
}
