/**
* \file single.cpp
*/
#include "CGameOverState.hpp"
#include <cmath>
#include <irrlicht.h>
#include "../entities/player.hpp"
#include "../config.hpp"
#include "../game_engine.hpp"
#include "../states/CMenuState.hpp"
#include "../states/COptionsState.hpp"
#include "../states/CScoreState.hpp"
#include "../states/CErrorState.hpp"
#include "../states/CTransitionState.hpp"
#include "../IdList.hpp"
#include "../utils/CParticleManager.hpp"
#include "../utils/CBitSet.hpp"
//#include "../entities/IMultiModeTransformer.hpp"
#include <fusion/scripting/CLuaThread.hpp>
#include <fusion/scripting/CLuaVM.hpp>
#include <fusion/maths/macros.hpp>
#include <fusion/core/string.hpp>
#include "../utils/CFadingImage.hpp"
#include "../CSpeech.hpp"
#include "../levels/ILevel.hpp"




using namespace irr;
using namespace video;
using namespace core;
using namespace scene;

//! Constructor
CGameOverState::CGameOverState()
:
_gameOverTab(0)
{


//    GUI_CreatePauseMenu();
//    GUI_CreateGameOverMenu();

    _gameOverTab->setVisible(false);

//    engine().showCursor(true);
};



//! Destructor
CGameOverState::~CGameOverState()
{
    //_world->remove();
//    delete _script;
}




///// Function Update()
//void
//CGameOverState::Update()
//{
//
//
////    _LOG_DEBUG << "starting updating CGameOverState with mode [" << getInnerState() << "]";
//
//    //(this->*_updateFunctions[ getInnerState() ])();
////callm
//
//}


void
CGameOverState::onResume() {

    //_player->setupForNewGame();
}

//void  CGameOverState::onHold() ;




//! Render a frame
// en gros l'ecran a une taille de 60
void
CGameOverState::Draw()
{


    _gameOverTab->draw();


}




//_player->getScore()






void
CGameOverState::onHold()
{


}





void
CGameOverState::GUI_CreateGameOverMenu()
{

    irr::core::recti tmp(0,0,0,0);
    core::recti rectButton = conf::_MENU_BUTTON_RECT;//(0,0,_BUTTON_WIDTH,_BUTTON_HEIGHT);

    _gameOverTab 	= gui()->addTab(tmp,gui()->getRootGUIElement());
    _gameOverTab->setRelativePositionProportional(core::rectf(0.4f,0.4f,1.f,1.f));



	// faudriat les mettre dans un mm container
	gui()->addButton(rectButton, _gameOverTab, NGuiId::ContinueGame,
			L"Continue", L"Continue game");
    rectButton += conf::_BUTTON_GAP;


    gui()->addButton(rectButton, _gameOverTab, NGuiId::SaveScore,
			L"Save score", L"Save score");
    rectButton += conf::_BUTTON_GAP;
//	gui->addButton(rect<s32>(10,320,110,320 + 32), 0, NGuiId::Credits,
//			L"File Open", L"Opens a file");

	gui()->addButton(rectButton, _gameOverTab, NGuiId::QuitGame,
			L"Quit game", L"Exits game");
}










/// \function HandleEvents
bool
CGameOverState::OnEvent(const irr::SEvent& event){



    //! According to event type
    switch(event.EventType){

        // HAndle GUI events
        case EET_GUI_EVENT:
            if(event.GUIEvent.EventType == gui::EGET_BUTTON_CLICKED){
                {
                    _INFO << "button clicked";
                    irr::s32 id = event.GUIEvent.Caller->getID();

                    switch(id)
                    {
                        case NGuiId::BackToGame:
                            //engine().SwitchBit(NBit::Pause,false);
                            //_pauseMenu->setVisible(false);
                            break;

                        case NGuiId::Options:
                            //IBasicGameStatePtr optionsState(new COptionState(core::rectf(0.2f,0.2f,0.8f,0.8f)) );
                            pushState(NStateId::Options);
                            //engine().pushEvent(NStateEvent::PushState,NStateId::Options);
                            break;

                        case NGuiId::SaveScore:
                            {
//
//                                this->popThisState();
//                                this->pushState();
/*
                                // donne la possibilit au joueur
                                // d'enregistrer son score
                                this->remove();
                                IBasicGameStatePtr menuState(new CMenuState());
                                engine().PushState( menuState );
                                //true,

                                CScoreState* scoreState = new CScoreState(core::rectf(0.2f,0.2f,0.8f,0.8f)) ;
                                IBasicGameStatePtr scoreStatePtr(scoreState);
                                engine().PushState( scoreStatePtr );
                                //if( state->getMinScore() < _player->getScore())
                                scoreState->displayAddScore( _player->getScore() );
                                */
                            }
                            break;

                        case NGuiId::ContinueGame:
                            break;

                        case NGuiId::QuitGame:
                            _INFO << "Exiting game from singleplayer state";
                            engine().Quit();

                        default:
                            break;
                    };
                }
            }
            break;

        default:
            break;
    } // end 1nd switch

    return false;
}



